#!/bin/bash

COMMUNITY=""
HOST=""
BASE_OID=""

while getopts "c:h:b:" option; do
  case $option in
    c) COMMUNITY=$OPTARG
      ;;
    h) HOST=$OPTARG
      ;;
    b) BASE_OID=$OPTARG
      ;;
    ?)
      echo "Usage $0 -c COMMUNITY -h HOST -b BASE_OID"
      exit 1
      ;;
  esac
done

if [ "$COMMUNITY" = "" ]; then
  echo "Set a community using -c"
  exit 1
fi

if [ "$HOST" = "" ]; then
  echo "Set a host using -h"
  exit 1
fi

if [ "$BASE_OID" = "" ]; then
  echo "Set a base oid using -b"
  exit 1
fi


snmpwalk -v 2c -c $COMMUNITY -On $HOST $BASE_OID | while read -r line; do 
  oid=`echo $line | awk '{print $1}'`
  textoid=`snmptranslate $oid`
  value=`echo $line | cut -d ' ' -f 3-`
  echo "$oid ($textoid): $value" 
done


